// -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-
/***
  BEGIN LICENSE

  Copyright (C) 2011-2012 Mario Guerriero <mefrio.g@gmail.com>
  This program is free software: you can redistribute it and/or modify it
  under the terms of the GNU Lesser General Public License version 3, as published
  by the Free Software Foundation.

  This program is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranties of
  MERCHANTABILITY, SATISFACTORY QUALITY, or FITNESS FOR A PARTICULAR
  PURPOSE.  See the GNU General Public License for more details.

  You should have received a copy of the GNU General Public License along
  with this program.  If not, see <http://www.gnu.org/licenses/>

  END LICENSE
***/

using Gtk;

namespace Scratch.Widgets {
    public class StatusBar : Gtk.Toolbar {

        public StatusBar () {

            set_orientation (Orientation.HORIZONTAL);
            
            get_style_context ().add_class ("status-toolbar");
            
            plugins.statusbar = this;
            plugins.hook_statusbar ();
        }
        
        public void check () {
            this.no_show_all = (get_children ().length () == 0);
            if (get_children ().length () == 0) this.hide ();
            else show_all ();
        }
        
        public void append (ToolItem widget) {
            this.insert (widget, -1);
            check ();
        }
    }
}
